## mingw-w64-moab-5.3.1-4.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.5 )
SET(PACKAGE_NAME "MOAB")
SET(PACKAGE_VERSION "5.3.1")

SET(CMAKE_CXX_STANDARD 11)
SET(CMAKE_CXX_STANDARD_REQUIRED ON)

if (NOT WIN32)
  #This all breaks on windows.
  SET(CMAKE_Fortran_COMPILER_INIT ${CMAKE_GENERATOR_FC})
  SET(CMAKE_CXX_FLAGS_INIT "-fPIC -DPIC")
  SET(CMAKE_CXX_FLAGS_DEBUG_INIT "-O0 -g")
  SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO_INIT "-O2 -g")
  SET(CMAKE_CXX_FLAGS_RELEASE_INIT "-O2 -DNDEBUG")
  SET(CMAKE_C_FLAGS_INIT "-fPIC -DPIC")
  SET(CMAKE_C_FLAGS_DEBUG_INIT "-O0 -g")
  SET(CMAKE_C_FLAGS_RELWITHDEBINFO_INIT "-O2 -g")
  SET(CMAKE_C_FLAGS_RELEASE_INIT "-O2 -DNDEBUG")
  SET(CMAKE_Fortran_FLAGS_INIT "-fPIC")
  SET(CMAKE_Fortran_FLAGS_DEBUG_INIT "-O0 -g")
  SET(CMAKE_Fortran_FLAGS_RELWITHDEBINFO_INIT "-O2 -g")
  SET(CMAKE_Fortran_FLAGS_RELEASE_INIT "-O2")
  SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS_INIT "")
  SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS_INIT "")
endif()

project( MOAB )

include(GNUInstallDirs)
include(FeatureSummary)

#Add our Cmake directory to the module search path
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/config ${CMAKE_MODULE_PATH})
################################################################################
# Set up version info
################################################################################
include (config/GetAcInitVersion.cmake)
get_ac_init_version()
set ( MOAB_VERSION_STRING "${PACKAGE_NAME} ${VERSION_STRING}" )
set ( MOAB_VERSION        "${VERSION_STRING}" )
set ( MOAB_VERSION_MAJOR  ${MAJOR_VERSION}  )
set ( MOAB_VERSION_MINOR  ${MINOR_VERSION}  )
if ( DEFINED PATCH_VERSION )
  set ( MOAB_VERSION_PATCH "${PATCH_VERSION}" )
else ( DEFINED PATCH_VERSION )
  if ( MOAB_VERSION_MINOR EQUAL 99 )
    set ( MOAB_VERSION_STRING "${MOAB_VERSION_STRING} (alpha)" )
  else ( MOAB_VERSION_MINOR EQUAL 99 )
    set ( MOAB_VERSION_STRING "${MOAB_VERSION_STRING} (beta)" )
  endif ( MOAB_VERSION_MINOR EQUAL 99 )
endif ( DEFINED PATCH_VERSION )

IF(CMAKE_VERSION VERSION_EQUAL "3.0.0" OR CMAKE_VERSION VERSION_GREATER "3.0.0")
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0020 NEW)
  #cmake_policy(SET CMP0042 OLD)
ENDIF ()
if (NOT (CMAKE_VERSION VERSION_LESS "3.12.0"))
# Allow use of <PackageName>_ROOT as a cmake variable
  cmake_policy(SET CMP0074 NEW)
endif ()


set ( abs_srcdir   ${CMAKE_SOURCE_DIR} )
set ( abs_builddir ${PROJECT_BINARY_DIR} )

################################################################################
# Install Related Settings
################################################################################

get_filename_component( MOAB_ABSSRC_DIR2 moab.make.in REALPATH )
execute_process( COMMAND dirname ${MOAB_ABSSRC_DIR2}
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  OUTPUT_VARIABLE MOAB_ABSSRC_DIR
  OUTPUT_STRIP_TRAILING_WHITESPACE
  )

## Set the directory where the binaries will be stored
set( EXECUTABLE_OUTPUT_PATH
  ${PROJECT_BINARY_DIR}/bin
  CACHE PATH
  "Directory where all executable will be stored"
)

## Set the directory where the libraries will be stored
set( LIBRARY_OUTPUT_PATH
  ${PROJECT_BINARY_DIR}/lib
  CACHE PATH
  "Directory where all the libraries will be stored"
)
mark_as_advanced(
  MOAB_ABSSRC_DIR
  EXECUTABLE_OUTPUT_PATH
  LIBRARY_OUTPUT_PATH)

include ( CheckIncludeFile )
include ( CheckFunctionExists )
include ( CheckTypeSize )

# Compiler defines... this should really be in a config file.
set( MOAB_DEFINES "" )
set( MOAB_LIBS )
set( MOAB_INSTALL_TARGETS )

################################################################################
# Options that the user controls
################################################################################
option ( BUILD_SHARED_LIBS   "Should shared or static libraries be created?"   ON  )
option ( ENABLE_CGM        "Should build with CGM support?"                  OFF )
option ( ENABLE_CGNS       "Should build with CGNS support?"                 OFF )
option ( ENABLE_MPI        "Should MOAB be compiled with MPI support?"       OFF )
option ( ENABLE_HDF5       "Include HDF I/O interfaces in the build?"                   OFF )
option ( ENABLE_ZLIB       "Include Zlib compression libraries (optionally used in HDF5)?"  OFF )
option ( ENABLE_SZIP       "Should build with szip support?"                 OFF )
option ( ENABLE_NETCDF     "Include NetCDF (ExodusII) interfaces in the build?" OFF )
option ( ENABLE_PNETCDF    "Include PNetCDF interfaces in the build (Requires NetCDF) ?" OFF )
option ( ENABLE_METIS      "Include Metis support for partitioning algorithms?" OFF )
option ( ENABLE_PARMETIS   "Include ParMetis support for partitioning algorithms?" OFF )
option ( ENABLE_ZOLTAN     "Include Zoltan support for partitioning algorithms?" OFF )
option ( ENABLE_VTK        "Include VTK I/O interfaces in the build?" OFF )
option ( ENABLE_TESTING    "Enable Testing"                                  ON  )
option ( MOAB_FORCE_64_BIT_HANDLES "Force MBEntityHandle to be 64 bits (uint64_t)" OFF )
option ( MOAB_FORCE_32_BIT_HANDLES "Force MBEntityHandle to be 32 bits (uint32_t)" OFF )
option ( ENABLE_PYMOAB       "Build python interface to MOAB?" OFF )
option ( ENABLE_IMESH        "Should build IMESH?"       ON )
option ( ENABLE_FBIGEOM      "Should build FBIGEOM?"     OFF )
option ( ENABLE_IREL         "Should build IREL?"        OFF )
option ( ENABLE_MESQUITE     "Should build Mesquite mesh optimization interfaces?" OFF )
option ( ENABLE_BLASLAPACK   "Should require BLAS/LAPACK?" ON )
option ( ENABLE_FORTRAN      "Should enable FORTRAN?" ON )
option ( ENABLE_TEMPESTREMAP "Should enable TempestRemap dependency?" OFF )

add_feature_info(SharedLibs BUILD_SHARED_LIBS "Should shared or static libraries be created?")
add_feature_info(EnableFortran ENABLE_FORTRAN "Should FORTRAN support be enabled?")

mark_as_advanced(
  MOAB_FORCE_64_BIT_HANDLES
  MOAB_FORCE_32_BIT_HANDLES
)

if ( ENABLE_IMESH OR ENABLE_FBIGEOM )
  include (${CMAKE_ROOT}/Modules/CMakeDetermineFortranCompiler.cmake)
endif ()

# patch added to ensure libs have a full-path ID set on Mac
if(APPLE)
  set(CMAKE_MACOSX_RPATH FALSE)
  set(CMAKE_INSTALL_NAME_DIR ${CMAKE_INSTALL_PREFIX}/lib)
endif()

################################################################################
# Check for system include files
################################################################################
check_include_file( inttypes.h   MOAB_HAVE_INTTYPES_H )
check_include_file( stdint.h     MOAB_HAVE_STDINT_H )
check_include_file( stddef.h     MOAB_HAVE_STDDEF_H )
check_include_file( stdlib.h     MOAB_HAVE_STDLIB_H )
check_include_file( sys/types.h  MOAB_HAVE_SYS_TYPES_H )
set( HAVE_SYS_TYPES_H ${MOAB_HAVE_SYS_TYPES_H} )
set( HAVE_STDDEF_H    ${MOAB_HAVE_STDDEF_H} )
set( HAVE_STDINT_H    ${MOAB_HAVE_STDINT_H} )
set( HAVE_INTTYPES_H    ${MOAB_HAVE_INTTYPES_H} )
set( HAVE_STDLIB_H    ${MOAB_HAVE_STDLIB_H} )
check_include_file( memory.h     MOAB_HAVE_MEMORY_H )

INCLUDE(TestBigEndian)
TEST_BIG_ENDIAN(WORDS_BIGENDIAN)
################################################################################
# Integer size Related Settings
################################################################################
if ( MOAB_FORCE_64_BIT_HANDLES AND MOAB_FORCE_32_BIT_HANDLES )
  message( FATAL_ERROR
      "You may not turn both MOAB_FORCE_64_BIT_HANDLES and MOAB_FORCE_32_BIT_HANDLES on. Turn one off to continue."
    )
endif ( MOAB_FORCE_64_BIT_HANDLES AND MOAB_FORCE_32_BIT_HANDLES )

if ( NOT MOAB_FORCE_64_BIT_HANDLES AND NOT MOAB_FORCE_32_BIT_HANDLES )
  if ( MOAB_HAVE_INTTYPES_H )
    set ( CMAKE_EXTRA_INCLUDE_FILES "${CMAKE_EXTRA_INCLUDE_FILES};inttypes.h" )
  endif ( MOAB_HAVE_INTTYPES_H )
  if ( MOAB_HAVE_STDLIB_H )
    set ( CMAKE_EXTRA_INCLUDE_FILES "${CMAKE_EXTRA_INCLUDE_FILES};stdlib.h" )
    #set ( CHECK_TYPE_SIZE_PREMAIN "${CHECK_TYPE_SIZE_PREMAIN}\n#include <stdlib.h>\n" )
  endif ( MOAB_HAVE_STDLIB_H )
  check_type_size(  size_t       MOAB_HAVE_SIZE_T )
  check_type_size(  ptrdiff_t    MOAB_HAVE_PTRDIFF_T )
  set ( HAVE_SIZE_T ${MOAB_HAVE_SIZE_T} )
  set ( HAVE_PTRDIFF_T ${MOAB_HAVE_PTRDIFF_T} )
endif ( NOT MOAB_FORCE_64_BIT_HANDLES AND NOT MOAB_FORCE_32_BIT_HANDLES )

# Check of presence of finite or isfinite macros
include (CheckFunctionExists)
CHECK_FUNCTION_EXISTS(std::isfinite MOAB_HAVE_STDISFINITE)
CHECK_FUNCTION_EXISTS(isfinite MOAB_HAVE_ISFINITE)
CHECK_FUNCTION_EXISTS(finite MOAB_HAVE_FINITE)

################################################################################
# Find packages
################################################################################

set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
set(THREADS_PREFER_PTHREAD_FLAG TRUE)
find_package(Threads REQUIRED)

include(config/CMakeLibraryFuncs.cmake)
include(GenerateExportHeader)
if (BUILD_SHARED_LIBS)
  if (WIN32)
    add_definitions(/DMOAB_DLL)
    if (NOT DEFINED CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS)
# https://cmake.org/cmake/help/v3.4/prop_tgt/WINDOWS_EXPORT_ALL_SYMBOLS.html
# Export all symbols
      set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D_USE_MATH_DEFINES")
    endif ()
  else ()
    # add_definitions(-DMOAB_DLL) # Not needed?
  endif ()
endif ()

set (MOAB_HAVE_BLAS OFF CACHE INTERNAL "Configured MOAB with BLAS library support." )
set (MOAB_HAVE_LAPACK OFF CACHE INTERNAL "Configured MOAB with LAPACK library support." )

if ( ENABLE_BLASLAPACK  )
  # Find BLAS
  FIND_PACKAGE(BLAS REQUIRED)
  if (BLAS_FOUND)
    set(MOAB_HAVE_BLAS ON)
  endif(BLAS_FOUND)
  set_package_properties(BLAS PROPERTIES
                       TYPE RECOMMENDED
                       PURPOSE "Native BLAS implementations")

  # Find LAPACK
  FIND_PACKAGE(LAPACK REQUIRED)
  if (LAPACK_FOUND)
    set(MOAB_HAVE_LAPACK ON)
  endif(LAPACK_FOUND)

  set_package_properties(LAPACK PROPERTIES
                       TYPE RECOMMENDED
                       PURPOSE "Native LAPACK implementations")

endif (ENABLE_BLASLAPACK)

if ( LAPACK_FOUND )

  SET (ENABLE_FORTRAN ON)

  # Eigen3 is optional if LAPACK has been found
  FIND_PACKAGE(Eigen3 OPTIONAL_COMPONENTS)

  set_package_properties(Eigen3 PROPERTIES
                       TYPE RECOMMENDED
                       PURPOSE "Eigen3 headers as supplement to BLAS/LAPACK implementations")

else ( LAPACK_FOUND )

  # Find Eigen3 is required if LAPACK is not found (or requested)
  FIND_PACKAGE(Eigen3 REQUIRED)

  set_package_properties(Eigen3 PROPERTIES
                        TYPE REQUIRED
                       PURPOSE "Eigen3 headers as replacement for BLAS/LAPACK implementations")

endif ( LAPACK_FOUND )

set (MOAB_HAVE_EIGEN3 OFF CACHE INTERNAL "Configured MOAB with Eigen3 library support." )
if ( EIGEN3_FOUND )
  INCLUDE_DIRECTORIES ( "${EIGEN3_DIR}" )
  SET(MOAB_DEFINES "${MOAB_DEFINES} ${EIGEN3_INCLUDES}")
  SET(MOAB_HAVE_EIGEN3 ON)
endif (EIGEN3_FOUND)

# check for MPI package
set (MOAB_HAVE_MPI OFF CACHE INTERNAL "Found necessary MPI components. Configure MOAB with it." )
if ( ENABLE_MPI )
  set (MPI_C_COMPILER ${CC} )
  set (MPI_CXX_COMPILER ${CXX} )
  set (MPI_Fortran_COMPILER ${FC} )
  find_package( MPI REQUIRED )
  # CMake FindMPI script is sorely lacking:
  if (MPI_C_COMPILER AND (NOT MPI_INCLUDE_PATH OR NOT MPI_LIBRARY))
    get_filename_component(MPI_BINDIR ${MPI_C_COMPILER} DIRECTORY)
    get_filename_component(MPI_ROOTDIR ${MPI_BINDIR} DIRECTORY)
  endif ()
  if (MPI_ROOTDIR AND (NOT MPI_INCLUDE_PATH) AND EXISTS ${MPI_ROOTDIR}/include)
    set(MPI_INCLUDE_PATH ${MPI_ROOTDIR}/include)
  endif ()
  if (MPI_ROOTDIR AND (NOT MPI_LIBRARY))
    find_library(MPI_LIBRARY mpi PATHS ${MPI_ROOTDIR} PATH_SUFFIXES lib64 lib)
  endif ()
  if ( MPI_LIBRARY AND MPI_INCLUDE_PATH )
    set( MPI_FOUND ON )
  endif ()

  if ( MPI_FOUND )
    set ( MOAB_DEFINES "${MOAB_DEFINES} -DUSE_MPI" )
    set(CMAKE_CXX_COMPILE_FLAGS "${CMAKE_CXX_COMPILE_FLAGS} ${MPI_COMPILE_FLAGS}")
    set(CMAKE_CXX_LINK_FLAGS "${CMAKE_CXX_LINK_FLAGS} ${MPI_LINK_FLAGS}")
    include_directories(${MPI_INCLUDE_PATH})
    set( MOAB_HAVE_MPI ON )

=== itaps/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set( SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P} )

configure_file(iBase_f.h.in "${CMAKE_CURRENT_BINARY_DIR}/iBase_f.h" @ONLY)

set( BASE_INCLUDE_HEADERS iBase.h ${CMAKE_CURRENT_BINARY_DIR}/iBase_f.h)

if (MOAB_HAVE_CGM)
  set(MOAB_HAVE_IGEOM ON PARENT_SCOPE)
endif(MOAB_HAVE_CGM)

if(ENABLE_IMESH )
  add_subdirectory(imesh)
  set(MOAB_HAVE_IMESH ON PARENT_SCOPE)
endif()

if(ENABLE_FBIGEOM )
  add_subdirectory(fbigeom)
  set(MOAB_HAVE_FBIGEOM ON PARENT_SCOPE)
endif()

if(ENABLE_IREL AND MOAB_HAVE_CGM )
  add_subdirectory(irel)
  set(MOAB_HAVE_IREL ON PARENT_SCOPE)
endif()

if (ENABLE_MESQUITE AND MOAB_HAVE_CGM)
  #add_subdirectory(mesquite)
  #set(MOAB_HAVE_MESQUITE ON PARENT_SCOPE)
endif(ENABLE_MESQUITE AND MOAB_HAVE_CGM)

install(
  FILES ${BASE_INCLUDE_HEADERS}
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  )

=== pymoab/requirements.txt ===
setuptools
numpy
cython>=0.26

=== test/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_BINARY_DIR}/src
    ${CMAKE_SOURCE_DIR}/src/io
    ${CMAKE_SOURCE_DIR}/itaps
    ${CMAKE_BINARY_DIR}/itaps
    ${CMAKE_SOURCE_DIR}/itaps/imesh
    ${CMAKE_BINARY_DIR}/itaps/imesh
    ${CMAKE_SOURCE_DIR}/src/parallel
    ${CMAKE_BINARY_DIR}/src/parallel )

add_subdirectory(io)
add_subdirectory(dual)
if( MOAB_HAVE_HDF5 )
  add_subdirectory(h5file)
endif()
add_subdirectory(obb)
add_subdirectory(perf)

set(TEST_COMP_FLAGS "-DMESHDIR=${MOAB_ABSSRC_DIR}/MeshFiles/unittest")

set( TESTS range_test.cpp
           verdict_test.cpp
           scdseq_test.cpp
           scd_test_partn.cpp
           test_adj.cpp
           GeomUtilTests.cpp
           oriented_box_test.cpp
           adaptive_kd_tree_tests.cpp
           kd_tree_test.cpp
           bsp_tree_test.cpp
           reorder_test.cpp
           elem_eval_test.cpp
           VarLenTagTest.cpp
           TagTest.cpp
           spatial_locator_test.cpp
           bsp_tree_poly_test.cpp
           test_prog_opt.cpp
           coords_connect_iterate.cpp
           urefine_mesh_test.cpp
           adj_moab_test.cpp
           test_boundbox.cpp
           spherical_area_test.cpp
           arc_intx_tests.cpp
           intx_in_plane_test.cpp
           intx_on_sphere_test.cpp )

if(MOAB_HAVE_HDF5)
  set( TESTS ${TESTS}
             lloyd_smoother_test.cpp
             mhdf_public_test.cpp
             mergemesh_test.cpp
             mbfacet_test.cpp
             mbground_test.cpp
             gttool_test.cpp
             restore_topo_geom_incl_test.cpp
             crop_vol_test.cpp
             imoab_test.cpp
	     gqt_simple_test.cpp
	     gqt_rayfire_test.cpp
	     gqt_pointinvol_test.cpp
            gqt_findvol_test.cpp
	     test_geom_gqt.cpp)
endif()

if(MOAB_HAVE_NETCDF)
  set ( TESTS ${TESTS}
              intx_rll_cs_sphere_test.cpp )
endif()

foreach( fname ${TESTS} )
  string( REPLACE ".cpp" "" base ${fname} )
  add_executable( ${base} ${CMAKE_SOURCE_DIR}/test/TestUtil.hpp ${fname})
  set_target_properties( ${base} PROPERTIES COMPILE_FLAGS "${TEST_COMP_FLAGS} ${MOAB_DEFINES} -DTEST" )
  target_link_libraries( ${base} MOAB ${CGM_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
  add_test( ${base} ${EXECUTABLE_OUTPUT_PATH}/${base} )
endforeach()

if(ENABLE_PYMOAB)
  SET(PYMOAB_TESTS test_core test_hom test_scd test_range test_tag test_topo_util test_skinner)
  FOREACH(pymoab_test ${PYMOAB_TESTS})
    ADD_TEST(NAME pymoab_${pymoab_test}
      COMMAND "env" "LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib/:$ENV{LD_LIBRARY_PATH}" "PYTHONPATH=${PROJECT_BINARY_DIR}/pymoab:$ENV{PYTHONPATH}" "${PYTHON}" "${pymoab_test}.py"
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/pymoab/tests/")
  ENDFOREACH(pymoab_test)
endif()

add_executable( TestTypeSequenceManager ${CMAKE_SOURCE_DIR}/test/TestUtil.hpp TestTypeSequenceManager.cpp)
set_target_properties( TestTypeSequenceManager PROPERTIES COMPILE_FLAGS "${TEST_COMP_FLAGS} ${MOAB_DEFINES} -DTEST -DIS_BUILDING_MB" )

set(TestTypeSequenceManager_LIBS MOAB ${CGM_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
if(${Threads_FOUND})
  list(APPEND TestTypeSequenceManager_LIBS Threads::Threads)
endif()
target_link_libraries(TestTypeSequenceManager ${TestTypeSequenceManager_LIBS})

add_test( TestTypeSequenceManager ${EXECUTABLE_OUTPUT_PATH}/TestTypeSequenceManager )

#Test_MBMeshSet.cpp
add_executable( Test_MBMeshSet ${CMAKE_SOURCE_DIR}/test/TestUtil.hpp Test_MBMeshSet.cpp)
set_target_properties( Test_MBMeshSet PROPERTIES COMPILE_FLAGS "${TEST_COMP_FLAGS} ${MOAB_DEFINES} -DTEST -DIS_BUILDING_MB" )
target_link_libraries( Test_MBMeshSet MOAB ${CGM_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
add_test( Test_MBMeshSet ${EXECUTABLE_OUTPUT_PATH}/Test_MBMeshSet )

if(ZCAT_EXE AND NOT WIN32)
  find_program( ZCAT_EXE NAMES zcap ZCAT PATHS /bin /usr/bin )
  add_custom_command( OUTPUT mb_big_test.g
                      COMMAND ${ZCAT_EXE} < ${MOAB_SOURCE_DIR}/MeshFiles/unittest/mb_big_test.g.gz > mb_big_test.g
                      DEPENDS ${MOAB_SOURCE_DIR}/MeshFiles/unittest/mb_big_test.g.gz )
  add_custom_command( OUTPUT cell1.gen
                      COMMAND ${ZCAT_EXE} < ${MOAB_SOURCE_DIR}/MeshFiles/unittest/cell1.gen.gz > cell1.gen
                      DEPENDS ${MOAB_SOURCE_DIR}/MeshFiles/unittest/cell1.gen.gz )
  add_custom_command( OUTPUT cell2.gen
                      COMMAND ${ZCAT_EXE} < ${MOAB_SOURCE_DIR}/MeshFiles/unittest/cell2.gen.gz > cell2.gen
                      DEPENDS ${MOAB_SOURCE_DIR}/MeshFiles/unittest/cell2.gen.gz)

  add_custom_target(moab_test_files DEPENDS mb_big_test.g cell1.gen cell2.gen)

  #MBTest.cpp:
  set_source_files_properties( MBTest.cpp
                               COMPILE_FLAGS "-DSRCDIR=${CMAKE_CURRENT_SOURCE_DIR} ${TEST_COMP_FLAGS}" )
  add_executable( moab_test MBTest.cpp )
  target_link_libraries( moab_test MOAB ${CGM_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
  add_dependencies(moab_test moab_test_files)
  add_test( TestMOAB ${EXECUTABLE_OUTPUT_PATH}/moab_test )
endif()

add_executable( var_len_test_no_template VarLenTagTest.cpp )
set_source_files_properties( VarLenTagTest.cpp
  COMPILE_FLAGS "-DMOAB_TEMPLATE_SPECIALIZATION ${MOAB_DEFINES} ${TEST_COMP_FLAGS}" )
target_link_libraries( var_len_test_no_template MOAB ${CGM_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
add_test( var_len_test_no_template ${EXECUTABLE_OUTPUT_PATH}/var_len_test_no_template )

add_executable( mbcn_test mbcn_test.cpp )
set_target_properties( mbcn_test PROPERTIES
  COMPILE_FLAGS "-DMOAB_TEMPLATE_SPECIALIZATION ${MOAB_DEFINES} ${TEST_COMP_FLAGS}" )
target_link_libraries( mbcn_test MOAB ${CGM_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
add_test( mbcn_test ${EXECUTABLE_OUTPUT_PATH}/mbcn_test )

add_executable( file_options_test ${CMAKE_SOURCE_DIR}/src/FileOptions.cpp )
set_source_files_properties( ${CMAKE_SOURCE_DIR}/src/FileOptions.cpp
                             COMPILE_FLAGS "-DTEST ${MOAB_DEFINES} ${TEST_COMP_FLAGS}" )
target_link_libraries( file_options_test MOAB ${CGM_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
add_test( file_options_test ${EXECUTABLE_OUTPUT_PATH}/file_options_test )

add_executable( homxform_test homxform_test.cpp )
set_source_files_properties( homxform_test.cpp
                             COMPILE_FLAGS "${MOAB_DEFINES} ${TEST_COMP_FLAGS}" )
target_link_libraries( homxform_test MOAB ${CGM_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
add_test( TestHomXform ${EXECUTABLE_OUTPUT_PATH}/homxform_test )

add_executable( xform_test affinexform_test.cpp )
set_source_files_properties( affinexform_test.cpp
                             COMPILE_FLAGS "${MOAB_DEFINES} ${TEST_COMP_FLAGS}" )
target_link_libraries( xform_test MOAB ${CGM_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
add_test( xform_test ${EXECUTABLE_OUTPUT_PATH}/xform_test )

#add imesh tests
if(ENABLE_IMESH)
  set( TESTS MOAB_iMesh_unit_tests.cpp
             MOAB_iMesh_extensions_tests.cpp )
  if(MOAB_HAVE_MPI)
    set(TESTS ${TESTS} MOAB_iMeshP_unit_tests.cpp )
  endif()
  foreach( fname ${TESTS} )
    string( REPLACE ".cpp" "" base ${fname} )
    add_executable( ${base} ${CMAKE_SOURCE_DIR}/test/TestUtil.hpp ${CMAKE_SOURCE_DIR}/itaps/imesh/${fname})
    set_target_properties( ${base} PROPERTIES COMPILE_FLAGS "-DSRCDIR=${CMAKE_SOURCE_DIR}/itaps/imesh/ ${TEST_COMP_FLAGS} ${MOAB_DEFINES} -DTEST" )
    target_link_libraries( ${base} iMesh MOAB ${CGM_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
    add_test( ${base} ${EXECUTABLE_OUTPUT_PATH}/${base} )
  endforeach()
endif()

if (ENABLE_IREL AND MOAB_HAVE_CGM)
  include_directories( ${CGM_INCLUDES} ${CMAKE_SOURCE_DIR}/itaps/irel ${CMAKE_BINARY_DIR}/itaps/irel )
  set( TESTS test_entset.cpp
             test_both.cpp
             test_status.cpp
             normals.cpp)
  set(irel_deplibs iRel)
  if(MOAB_HAVE_FBIGEOM)
    include_directories( ${CMAKE_SOURCE_DIR}/itaps/fbigeom ${CMAKE_BINARY_DIR}/itaps/fbigeom )
    set(TESTS ${TESTS} test_entsetFB.cpp )
    set(irel_deplibs ${irel_deplibs} FBiGeomMOAB)
  endif()
  set(irel_deplibs ${irel_deplibs} iMesh MOAB)
  foreach( fname ${TESTS} )
    string( REPLACE ".cpp" "" base ${fname} )
    add_executable( ${base} ${CMAKE_SOURCE_DIR}/test/TestUtil.hpp ${CMAKE_SOURCE_DIR}/itaps/irel/${fname})
    set_target_properties( ${base} PROPERTIES COMPILE_FLAGS "-DSRCDIR=${CMAKE_SOURCE_DIR}/itaps/irel/ ${TEST_COMP_FLAGS} ${MOAB_DEFINES} -DTEST" )
    target_link_libraries( ${base} ${irel_deplibs} ${CGM_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
    add_test( ${base} ${EXECUTABLE_OUTPUT_PATH}/${base} )
  endforeach()
endif()

if (ENABLE_MESQUITE AND MOAB_HAVE_CGM)
  # add_subdirectory(mesquite)
endif(ENABLE_MESQUITE AND MOAB_HAVE_CGM)

if ( MOAB_HAVE_MPI AND MPI_FOUND )

  add_executable ( mbparallelcomm_test parallel/mbparallelcomm_test.cpp )
  target_link_libraries( mbparallelcomm_test MOAB ${CGM_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
  set_source_files_properties( parallel/mbparallelcomm_test.cpp
    COMPILE_FLAGS "-DIS_BUILDING_MB ${MOAB_DEFINES} ${TEST_COMP_FLAGS}" )
  add_test( TestParallelComm-BcastDelete
    ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS}
    ${EXECUTABLE_OUTPUT_PATH}/mbparallelcomm_test ${MPIEXEC_POSTFLAGS} 0 ${CMAKE_SOURCE_DIR}/parallel/ptest.cub )
  add_test( TestParallelComm-ReadDelete
    ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS}
    ${EXECUTABLE_OUTPUT_PATH}/mbparallelcomm_test ${MPIEXEC_POSTFLAGS} -1 ${CMAKE_SOURCE_DIR}/parallel/ptest.cub )
  add_test( TestParallelComm-ReadParallel
    ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS}
    ${EXECUTABLE_OUTPUT_PATH}/mbparallelcomm_test ${MPIEXEC_POSTFLAGS} -2 ${CMAKE_SOURCE_DIR}/parallel/ptest.cub )
  add_test( TestParallelComm-Broadcast
    ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS}
    ${EXECUTABLE_OUTPUT_PATH}/mbparallelcomm_test ${MPIEXEC_POSTFLAGS} -3 ${CMAKE_SOURCE_DIR}/parallel/ptest.cub )

  if ( MOAB_HAVE_HDF5 )
    include_directories(
      ${HDF5_INCLUDES}
      ${CMAKE_SOURCE_DIR}/src/io/mhdf/include
    )
    set_source_files_properties( parallel/mhdf_parallel.c
      COMPILE_FLAGS "-DTEST ${MOAB_DEFINES} ${TEST_COMP_FLAGS}" )
    add_executable( mhdf_parallel parallel/mhdf_parallel.c )
    target_link_libraries( mhdf_parallel MOAB ${HDF5_LIBRARIES} ${CGM_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
    add_test( TestMHDFParallel ${EXECUTABLE_OUTPUT_PATH}/mhdf_parallel )

    set_source_files_properties( parallel/parmerge_test.cpp
      COMPILE_FLAGS "-DTEST ${MOAB_DEFINES} ${TEST_COMP_FLAGS}" )
    add_executable( parmerge_test parallel/parmerge_test.cpp )
    target_link_libraries( parmerge_test MOAB ${HDF5_LIBRARIES} ${CGM_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
    add_test( Testparmerge_test ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ${EXECUTABLE_OUTPUT_PATH}/parmerge_test ${MPIEXEC_POSTFLAGS}  )

  endif ( MOAB_HAVE_HDF5 )

  set_source_files_properties( parallel/parallel_unit_tests.cpp
    COMPILE_FLAGS "-DTEST ${MOAB_DEFINES} ${TEST_COMP_FLAGS}" )
  add_executable ( parallel_unit_tests parallel/parallel_unit_tests.cpp )
  target_link_libraries( parallel_unit_tests MOAB ${CGM_LIBRARIES} ${MPI_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
  add_test( TestParallel
    ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 2 ${MPIEXEC_PREFLAGS} ${EXECUTABLE_OUTPUT_PATH}/parallel_unit_tests ${MPIEXEC_POSTFLAGS} )

  set_source_files_properties( parallel/pcomm_serial.cpp
    COMPILE_FLAGS "-DTEST ${MOAB_DEFINES} ${TEST_COMP_FLAGS}" )
  add_executable ( pcomm_serial parallel/pcomm_serial.cpp )
  target_link_libraries( pcomm_serial MOAB ${CGM_LIBRARIES} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
  add_test( TestPCommSerial
    ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 1 ${MPIEXEC_PREFLAGS}
    ${EXECUTABLE_OUTPUT_PATH}/pcomm_serial ${MPIEXEC_POSTFLAGS} 1 ${MOAB_SOURCE_DIR}/MeshFiles/unittest/ptest.cub )

=== examples/cmake/CMakeLists.txt ===
####################################################################################
#       MOAB - CMake downstream application configuration/compilation template     #
#                                                                                  #
#  Configuration Usage:                                                            #
#       cmake -DMOAB_ROOT=${PATH_TO_MOAB_INSTALLATION} ${EXAMPLE_SRC_PATH}         #
####################################################################################
##                           DO NOT MODIFY BELOW                                  ##
####################################################################################
cmake_minimum_required ( VERSION 2.8.12 )

set ( MOAB_ROOT "" CACHE PATH "Path to MOAB library installation" )

find_package(MOAB REQUIRED
  HINTS ${MOAB_ROOT} ${MOAB_ROOT}/lib/cmake/MOAB)

#Add our Cmake directory to the module search path
set ( CMAKE_MODULE_PATH ${MOAB_DIR} ${CMAKE_MODULE_PATH} )

set ( CMAKE_C_COMPILER ${MOAB_CC} )
set ( CMAKE_CXX_COMPILER ${MOAB_CXX} )
set ( CMAKE_Fortran_COMPILER ${MOAB_FC} )
set ( CMAKE_C_FLAGS ${MOAB_C_FLAGS} )
set ( CMAKE_CXX_FLAGS ${MOAB_CXX_FLAGS} )
set ( CMAKE_Fortran_FLAGS ${MOAB_FC_FLAGS} )
set ( CMAKE_CXX_LINK_FLAGS ${CMAKE_CXX_LINK_FLAGS} )

if ( ENABLE_IMESH )
  enable_language(Fortran)
endif ( ENABLE_IMESH )

message ( "++ Found MOAB configuration details at: ${MOAB_DIR}" )

####################################################################################
##                      MODIFY BELOW AS NECESSARY                                 ##
##     (Replace `ExampleMOABProgram` with your source file name)                  ##
####################################################################################

project (MOAB_CMAKE_TEMPLATE_EXAMPLE)

include_directories(${MOAB_INCLUDE_DIRS})

add_executable(ExampleMOABProgram ExampleMOABProgram.cpp)
set_target_properties( ExampleMOABProgram PROPERTIES COMPILE_FLAGS "'-DMESH_DIR=\"${MOAB_MESH_DIR}\"' ${TEST_COMP_FLAGS} ${MOAB_DEFINES}" )
target_link_libraries( ExampleMOABProgram LINK_PUBLIC ${MOAB_LIBRARIES} )

=== itaps/fbigeom/CMakeLists.txt ===
set( FBiGEOM_SOURCE FBiGeom_MOAB.hpp FBiGeom_MOAB.cpp )
set(
  FBiGEOM_INCLUDE_HEADERS
  FBiGeom.h
  FBiGeom_protos.h
  FBiGeom_f.h
  )

add_library(
  FBiGeomMOAB
  ${FBiGEOM_SOURCE}
  ${FBiGEOM_INCLUDE_HEADERS}
  )

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_BINARY_DIR}/src
  ${CMAKE_SOURCE_DIR}/src
  ${CMAKE_SOURCE_DIR}/itaps
  ${CMAKE_BINARY_DIR}/itaps
  ${CMAKE_SOURCE_DIR}/itaps/imesh
  ${CMAKE_BINARY_DIR}/itaps/imesh
 )

if ( MOAB_HAVE_MPI )
  include_directories( ${CMAKE_SOURCE_DIR}/src/parallel
                       ${CMAKE_BINARY_DIR}/src/parallel)
endif ()

target_link_libraries( FBiGeomMOAB iMesh MOAB ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )

set_target_properties(
  FBiGeomMOAB
  PROPERTIES
  VERSION ${MOAB_VERSION}
  SOVERSION ${MOAB_VERSION_MAJOR}
  )

install(
  TARGETS FBiGeomMOAB
  EXPORT MOABTargets
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )
set( MOAB_INSTALL_TARGETS ${MOAB_INSTALL_TARGETS} FBiGeomMOAB)

install(
  FILES ${FBiGEOM_INCLUDE_HEADERS}
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  )

=== itaps/mesquite/CMakeLists.txt ===

set ( MOAB_MESQUITE_SRCS  MsqMOAB.cpp )
set ( MOAB_MESQUITE_LIB_INCLUDES MsqMOAB.hpp )

set(IMESQUITE_LINK_LIBS )

if (ENABLE_CGM)
  include_directories( ${CGM_INCLUDE_DIRS} )
  set(IMESQUITE_LINK_LIBS ${IGEOM_LIBS} ${CGM_LIBRARIES})
  set(MOAB_MESQUITE_SRCS ${MOAB_MESQUITE_SRCS} MsqIGeom.cpp )
  set(MOAB_MESQUITE_LIB_INCLUDES ${MOAB_MESQUITE_LIB_INCLUDES} MsqIGeom.hpp )
endif()

if (ENABLE_IMESH)
  include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/src/itaps/imesh ${CMAKE_CURRENT_BINARY_DIR}/src/itaps/imesh )
  set(IMESQUITE_LINK_LIBS iMesh ${IMESQUITE_LINK_LIBS})
  set(MOAB_MESQUITE_SRCS ${MOAB_MESQUITE_SRCS} MsqIMesh.cpp )
  set(MOAB_MESQUITE_LIB_INCLUDES ${MOAB_MESQUITE_LIB_INCLUDES} MsqIMesh.hpp )

if (MOAB_HAVE_MPI)
  include_directories( ${MPI_INCLUDE_DIRS} )
  set(IMESQUITE_LINK_LIBS ${MPI_LIBRARIES})

  set(MOAB_MESQUITE_SRCS ${MOAB_MESQUITE_SRCS} MsqIMeshP.cpp )
  set(MOAB_MESQUITE_LIB_INCLUDES ${MOAB_MESQUITE_LIB_INCLUDES} MsqIMeshP.hpp )
endif()

endif()

if (ENABLE_IREL)
  include_directories( ${CGM_INCLUDE_DIRS} )
  set(IMESQUITE_LINK_LIBS ${IMESQUITE_LINK_LIBS} ${IGEOM_LIBS} ${CGM_LIBRARIES})

  set(MOAB_MESQUITE_SRCS iRel ${MOAB_MESQUITE_SRCS} MsqIRel.cpp )
  set(MOAB_MESQUITE_LIB_INCLUDES ${MOAB_MESQUITE_LIB_INCLUDES} MsqIRel.hpp )
endif()

set(IMESQUITE_LINK_LIBS MOAB ${IMESQUITE_LINK_LIBS})
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_BINARY_DIR}/src
  ${CMAKE_SOURCE_DIR}/src
  ${CMAKE_SOURCE_DIR}/itaps
  ${CMAKE_BINARY_DIR}/itaps
  )

if ( MOAB_HAVE_HDF5 AND HDF5_FOUND )
  include_directories( ${HDF5_INCLUDE_DIRECTORIES}
                       ${CMAKE_SOURCE_DIR}/src/io/mhdf/include )
endif( )

set_source_files_properties(
  ${MOAB_MESQUITE_SRCS} COMPILE_FLAGS "${MOAB_DEFINES}"
  )

add_library(
  MsqITAPS
  ${MOAB_MESQUITE_SRCS}
  ${MOAB_MESQUITE_LIB_INCLUDES}
  )

target_link_libraries( MsqITAPS ${IMESQUITE_LINK_LIBS} )

set_target_properties(
  MsqITAPS
  PROPERTIES
  VERSION ${MOAB_VERSION}
  SOVERSION ${MOAB_VERSION_MAJOR}
  )

install(
  TARGETS MsqITAPS
  EXPORT MOABTargets
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )
set( MOAB_INSTALL_TARGETS ${MOAB_INSTALL_TARGETS} MsqITAPS)

install(
  FILES ${MOAB_MESQUITE_LIB_INCLUDES}
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  )

=== pymoab/pymoab/CMakeLists.txt ===


# create symlinks for all fiels in directory
FILE(GLOB PYMOAB_FILES ${CMAKE_CURRENT_SOURCE_DIR} "*")
IF(NOT ${CMAKE_SOURCE_DIR} MATCHES ${CMAKE_BINARY_DIR})
  FOREACH(PYMOAB_FILE ${PYMOAB_FILES})
    GET_FILENAME_COMPONENT(FILE ${PYMOAB_FILE} NAME)
    EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E create_symlink ${PYMOAB_FILE} ${CMAKE_CURRENT_BINARY_DIR}/${FILE})
  ENDFOREACH(PYMOAB_FILE)
ENDIF()

=== src/io/CMakeLists.txt ===
include_directories( ${MOAB_BINARY_DIR}/src
                     ${MOAB_SOURCE_DIR}/src
                     ${MOAB_SOURCE_DIR}/src/io
                     ${MOAB_SOURCE_DIR}/src/mhdf
                     ${MOAB_BINARY_DIR}/src/parallel
                    )
set( MOABIO_LIBS )
set( MOABIO_DEFINES "-DIS_BUILDING_MB" )
set( MOABIO_INSTALL_HEADERS moab/ExoIIInterface.hpp  moab/VtkUtil.hpp)
set( MOABIO_LIB_SRCS
        exodus_order.h
        patran_order.h
        IODebugTrack.hpp  IODebugTrack.cpp
        ExoIIUtil.hpp     ExoIIUtil.cpp
        FileTokenizer.hpp FileTokenizer.cpp
        GmshUtil.hpp      GmshUtil.cpp
        ReadABAQUS.hpp    ReadABAQUS.cpp
        ReadGmsh.hpp      ReadGmsh.cpp
        ReadIDEAS.hpp     ReadIDEAS.cpp
        ReadMCNP5.hpp     ReadMCNP5.cpp
        ReadNASTRAN.hpp   ReadNASTRAN.cpp
        ReadRTT.hpp       ReadRTT.cpp
        ReadOBJ.hpp       ReadOBJ.cpp
        ReadSmf.hpp       ReadSmf.cpp
        ReadSms.hpp       ReadSms.cpp
        ReadSTL.hpp       ReadSTL.cpp
        ReadTemplate.hpp  ReadTemplate.cpp
        ReadTetGen.hpp    ReadTetGen.cpp
        ReadVtk.hpp       ReadVtk.cpp
        SMF_State.hpp     SMF_State.cpp
        Tqdcfr.hpp        Tqdcfr.cpp
                          VtkUtil.cpp
        WriteAns.hpp      WriteAns.cpp
        WriteGMV.hpp      WriteGMV.cpp
        WriteGmsh.hpp     WriteGmsh.cpp
        WriteSTL.hpp      WriteSTL.cpp
        WriteSmf.hpp      WriteSmf.cpp
        WriteTemplate.hpp WriteTemplate.cpp
        WriteVtk.hpp      WriteVtk.cpp )

if( MOAB_HAVE_NETCDF )
  set( MOAB_NETCDF_SRCS
          ReadNCDF.hpp      ReadNCDF.cpp
          WriteNCDF.hpp     WriteNCDF.cpp
          WriteSLAC.hpp     WriteSLAC.cpp
          ReadNC.hpp        ReadNC.cpp
          WriteNC.hpp       WriteNC.cpp
          NCHelper.hpp      NCHelper.cpp
          NCWriteHelper.hpp NCWriteHelper.cpp
          NCHelperEuler.hpp NCHelperEuler.cpp
          NCWriteEuler.hpp  NCWriteEuler.cpp
          NCHelperFV.hpp    NCHelperFV.cpp
          NCHelperDomain.hpp    NCHelperDomain.cpp
          NCWriteFV.hpp     NCWriteFV.cpp
          NCHelperGCRM.hpp  NCHelperGCRM.cpp
          NCWriteGCRM.hpp   NCWriteGCRM.cpp
          NCHelperHOMME.hpp NCHelperHOMME.cpp
          NCWriteHOMME.hpp  NCWriteHOMME.cpp
          NCHelperMPAS.hpp  NCHelperMPAS.cpp
          NCWriteMPAS.hpp   NCWriteMPAS.cpp
       )
        set( MOABIO_LIBS ${MOABIO_LIBS} ${NETCDF_LIBRARIES} )
        include_directories(${NETCDF_INCLUDES})
  # check for PNetCDF dependencies also
  if( MOAB_HAVE_PNETCDF )
    set( MOABIO_LIBS ${MOABIO_LIBS} ${PNETCDF_LIBRARIES} )
    include_directories(${PNETCDF_INCLUDES})
  endif( MOAB_HAVE_PNETCDF )
endif( MOAB_HAVE_NETCDF )

if( MOAB_HAVE_ZOLTAN )
  include_directories(${ZOLTAN_INCLUDES})
endif (MOAB_HAVE_ZOLTAN)

if ( MOAB_HAVE_CGNS )
  set( MOAB_CGNS_SRCS ReadCGNS.hpp ReadCGNS.cpp
                      WriteCGNS.hpp WriteCGNS.cpp)
endif()

if( MOAB_HAVE_HDF5 )
  add_subdirectory( mhdf )
  set( MOAB_HDF5_SRCS
          HDF5Common.hpp HDF5Common.cpp
          ReadHDF5.hpp ReadHDF5.cpp
          ReadHDF5Dataset.hpp ReadHDF5Dataset.cpp
          ReadHDF5VarLen.hpp ReadHDF5VarLen.cpp
          WriteHDF5.cpp WriteHDF5.hpp )
  set( MDHF_OBJ $<TARGET_OBJECTS:mhdf> PARENT_SCOPE )
  set( MOABIO_LIBS ${MOABIO_LIBS} ${HDF5_LIBRARIES} )
  include_directories(${HDF5_INCLUDES})
  set(CMAKE_REQUIRED_LIBRARIES_SAV ${CMAKE_REQUIRED_LIBRARIES})
  set(CMAKE_REQUIRED_LIBRARIES ${MOABIO_LIBS})
  check_function_exists( H5Pset_fapl_mpio MOAB_HDF_HAVE_PARALLEL )
  set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES_SAV})
endif()

if( MOAB_HAVE_CCMIO )
  set( MOAB_CCMIO_SRCS WriteCCMIO.hpp WriteCCMIO.cpp
                       ReadCCMIO.hpp ReadCCMIO.cpp )
endif()

if( MOAD_HAVE_DAMSEL )
  set( MOAB_DAMSEL_SRCS
          WriteDamsel.hpp WriteDamsel.cpp
          ReadDamsel.hpp  ReadDamsel.cpp
          DamselUtil.hpp  DamselUtil.cpp )
endif()

if( MOAB_HAVE_CGM )
  set( MOAB_CGM_SRCS ReadCGM.hpp ReadCGM.cpp )
  include_directories(${CGM_INCLUDES})
endif()

add_library( moabio OBJECT ${MOABIO_LIB_SRCS} ${MOAB_NETCDF_SRCS}
                           ${MOAB_CGNS_SRCS}  ${MOAB_HDF5_SRCS}
                           ${MOAB_CCMIO_SRCS} ${MOAB_DAMSEL_SRCS}
                           ${MOAB_CGM_SRCS}   ${MOABIO_INSTALL_HEADERS} )
set_target_properties( moabio PROPERTIES COMPILE_FLAGS "${MOABIO_DEFINES} ${MOAB_DEFINES}")
include(AutoconfHeader)
moab_install_headers(${MOABIO_INSTALL_HEADERS})

=== src/mesquite/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_CURRENT_BINARY_DIR}
                    parallel
                    LocalDiscretization
                    io io/mhdf
                    ${MOAB_BINARY_DIR}/src/parallel )

# Include the makefile to get all headers and sources
include (${CMAKE_CURRENT_SOURCE_DIR}/make.cmake.inc)
#add_subdirectory(Control)
#add_subdirectory(MappingFunction)
#add_subdirectory(Mesh)
#add_subdirectory(Misc)
#add_subdirectory(ObjectiveFunction)
#add_subdirectory(QualityAssessor)
#add_subdirectory(QualityImprover)
#add_subdirectory(QualityMetric)
#add_subdirectory(TargetCalculator)
#add_subdirectory(TargetMetric)
#add_subdirectory(Wrappers)

set(MESQUITE_LIB_SOURCES ${MSQ_SRCS} )

set( MESQUITE_INSTALL_HEADERS ${MSQ_HDRS} )

add_library( moabmesquite OBJECT ${MESQUITE_LIB_SRCS} ${MESQUITE_INSTALL_HEADERS} )
set_target_properties( moabmesquite PROPERTIES COMPILE_FLAGS "${MESQUITE_DEFINES} ${MOAB_DEFINES}")
include(AutoconfHeader)
moab_install_headers(${MESQUITE_INSTALL_HEADERS})

=== test/perf/CMakeLists.txt ===
add_subdirectory(point_location)
set( LIBS MOAB ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} )
set( TESTS adj_mem_time_test.cpp
           )

if(MOAB_HAVE_HDF5)
  set( TESTS ${TESTS} adj_time.cpp )
endif(MOAB_HAVE_HDF5)

set( TOOLS seqperf.cpp
           perf.cpp
           perftool.cpp
           umr_perf.cpp )

if ( MOAB_HAVE_IMESH )
  set(TESTS ${TESTS} tstt_perf_binding.cpp)
  set(tstt_perf_binding_CMDARGS 4;B)
  set(LIBS ${LIBS} iMesh )
endif()
if ( MOAB_HAVE_CGM )
  set(LIBS ${LIBS} ${CGM_LIBRARIES})
endif()

set(TEST_COMP_FLAGS "-DMESHDIR=${MOAB_ABSSRC_DIR}/MeshFiles/unittest")

foreach( fname ${TESTS} )
  string( REPLACE ".cpp" "" tmp ${fname} )
  string( REPLACE ".cc" "" base ${tmp} )
  add_executable( ${base} ${CMAKE_SOURCE_DIR}/test/TestUtil.hpp ${fname})
  set_target_properties( ${base} PROPERTIES COMPILE_FLAGS "${MOAB_DEFINES} ${TEST_COMP_FLAGS} -DTEST" )
  target_link_libraries( ${base} ${LIBS} )
  add_test( ${base} ${EXECUTABLE_OUTPUT_PATH}/${base} ${${base}_CMDARGS} )
endforeach()

foreach( fname ${TOOLS} )
  string( REPLACE ".cpp" "" tmp ${fname} )
  string( REPLACE ".cc" "" base ${tmp} )
  add_executable( ${base} ${CMAKE_SOURCE_DIR}/test/TestUtil.hpp ${fname})
  set_target_properties( ${base} PROPERTIES COMPILE_FLAGS "${MOAB_DEFINES} ${TEST_COMP_FLAGS} -DTEST" )
  target_link_libraries( ${base} ${LIBS} )
  message("linking: ${base} ${LIBS}" )
endforeach()

=== test/mesquite/unit/CMakeLists.txt ===


SET( unit_tests
     ArrayMeshTest
     AspectRatioGammaTest
     AveragingQMTest
     AWMetricTest
     AWQualityMetricTest
     BCDTest
     BoundedCylinderDomainTest
     CachingTargetTest
     CircleDomainTest
     CompositeMetricTest
     CompositeOFTest
     ConditionNumberTest
     ConicDomainTest
     CylinderDomainTest
     DomainClassifierTest
     EdgeLengthMetricTest
     EdgeLengthQualityMetricTest
     ElemSampleQMTest
     ExtraDataTest
     FileTokenizerTest
     GeomPrimTest
     HexLagrangeShapeTest
     HigherOrderTest
     IdealElementTest
     IdealTargetTest
     IdealWeightMeanRatioTest
     IdealWeightInverseMeanRatioTest
     InstructionQueueTest
     LinearMappingFunctionTest
     LineDomainTest
     LVQDTargetTest
     MappingFunctionTest
     Matrix3DTest
     MeshInterfaceTest
     MeshImplTest
     MiscTargetMetricTests
     MsqFreeVertexIndexIteratorTest
     MsqHessianTest
     MsqMatrixTest
     MsqMeshEntityTest
     MsqVertexTest
     NodeSetTest
     NumericalOFTest
     ObjectiveFunctionTest
     PatchDataTest
     PatchDataTestNormals
     PatchSetTest
     PlanarGeometryTest
     PMeanPMetricTest
     PMeanPTemplateTest
     QuadLagrangeShapeTest
     QualityAssessorTest
     QualityMetricTest
     ShapeOrientTargetMetricTests
     ShapeSizeOrientTargetMetricTests
     ShapeSizeTargetMetricTests
     ShapeTargetMetricTests
     SizeTargetMetricTests
     SlaveBoundaryVerticesTest
     SphericalDomainTest
     SphericalGeometryTest
     StdDevTemplateTest
     SymMatrix3DTest
     TagVertexMeshTest
     TargetCalculatorTest
     TargetReadWriteTest
     TerminationCriterionTest
     TetLagrangeShapeTest
     TriLagrangeShapeTest
     TopologyInfoTest
     TMPDerivsTest
     TMetricTest
     TQualityMetricTest
     UntangleBetaTest
     UntangleTargetMetricTests
     Vector3DTest
     VertexConditionNumberTest
     VertexCullingRegressionTest
     VtkTest
     XYRectangleTest )

SET( unit_libs ${CPPUNIT_LIBRARY} )

IF (${PACKAGE_NAME}_ENABLE_IMESH)
  SET(unit_tests ${unit_tests} iMeshTest)
  SET(unit_libs ${unit_libs} ${IMESH_LIBRARY})
ENDIF()

IF (${PACKAGE_NAME}_ENABLE_ExodusII)
  SET(unit_tests ${unit_tests} ExodusTest)
  SET(unit_libs ${unit_libs} ${EXODUS_LIBRARY})
ENDIF()

SET( unit_srcs
     msq_test_main.cpp
     QualityMetricTester.cpp
     MBMesquiteTestRunner.hpp
     ObjectiveFunctionTests.hpp
     ObjectiveFunctionTests.cpp
     PatchDataInstances.hpp
     QualityMetricTester.hpp
     UnitUtil.hpp
     TargetMetricTest.hpp
     TMPQualityMetricTest.hpp )

FOREACH( test ${unit_tests} )
  SET( unit_srcs ${unit_srcs} ${test}.cpp )
ENDFOREACH()

IF (NOT ${PROJECT_NAME} STREQUAL "Mesquite")
  TRIBITS_ADD_EXECUTABLE( msq_test SOURCES ${unit_srcs} DEPLIBS ${CPPUNIT_LIBRARY} )
#  TARGET_LINK_LIBRARIES( msq_test mesquite ${CPPUNIT_LIBRARY} )
  FOREACH( test ${unit_tests} )
    TRIBITS_ADD_TEST( msq_test NAME ${test} ARGS ${test} NUM_MPI_PROCS 1 )
  ENDFOREACH()
ELSE()
  IF (${PACKAGE_NAME}_ENABLE_TESTS)
    ADD_EXECUTABLE( msq_test ${unit_srcs} )
    TARGET_LINK_LIBRARIES( msq_test mesquite ${CPPUNIT_LIBRARY} )
    FOREACH( test ${unit_tests} )
      ADD_TEST( ${test} ${EXECUTABLE_OUTPUT_PATH}/msq_test ${test} )
    ENDFOREACH()
  ENDIF()
ENDIF()

INCLUDE_DIRECTORIES( ${CPPUNIT_INCLUDES} )
SET_SOURCE_FILES_PROPERTIES(${unit_srcs} COMPILE_FLAGS "${TEST_DEFINES} -DSRCDIR=\"\\\"${CMAKE_CURRENT_SOURCE_DIR}\\\"\"")

=== PKGBUILD ===
# Maintainer: Rafal Brzegowy <rafal.brzegowy@yahoo.com>

_realname=moab
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=5.3.1
pkgrel=4
pkgdesc='The Mesh-Oriented datABase MOAB is a component for representing and evaluating mesh data (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
url='https://sigma.mcs.anl.gov/moab-library/'
license=('spdx:LGPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-openblas")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-msmpi")
source=(https://ftp.mcs.anl.gov/pub/fathom/${_realname}-${pkgver}.tar.gz
        "0001-no-fortran.patch")
sha256sums=('2404fab2d84f87be72b57cfef5ea237bfa444aaca059e66a158f22134956fe54'
            '2669507edebea057297ef7fb4e4ced4e5bc2ac350da78b24ac51a7bcb3559a94')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Nbp1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd ${srcdir}/${_realname}-${pkgver}
  apply_patch_with_msg \
    0001-no-fortran.patch
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    _extra_config+=("-DENABLE_FORTRAN=OFF")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DBUILD_SHARED_LIBS=OFF \
      -DENABLE_MPI=ON \
      -DENABLE_TESTING=OFF \
      "${_extra_config[@]}" \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install .
  install -Dm644 ${srcdir}/${_realname}-${pkgver}/LICENSE ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
